#include "input.h"

bool isbuttonpressed = false;
bool iskeypressed = false;

SDLKey key = SDLK_UNKNOWN;
Uint8 button = 0;

int mouse_dx = 0;
int mouse_dy = 0;

bool isButtondown(void)
{
	return isbuttonpressed;
}

bool isKeydown(void)
{
	return iskeypressed;
}

SDLKey getKey(void)
{
	return key;
}

Uint8 getButton(void)
{
	return SDL_BUTTON(button);
}
bool isKeypressed(void)
{		
	return iskeypressed; 
}

bool isButtonpressed(void)
{				
	return isbuttonpressed;
}

bool isKeypressed(SDLKey Key)
{		
	return (CRM32Pro.GetKeystate(Key)==1); 
}

bool isButtonpressed(int Button)
{				
	return (CRM32Pro.mouse_buttons == SDL_BUTTON(Button));
}

bool isMouseover(int x, int y, int w, int h)
{
	return ( CRM32Pro.mouse_x >= x && CRM32Pro.mouse_x < (x + w) &&
			 CRM32Pro.mouse_y >= y && CRM32Pro.mouse_y < (y + h) );
}

bool isMouseover(SDL_Rect Area)
{
	return isMouseover(Area.x, Area.y, Area.w, Area.h);
}

int getMousex(void)
{
	return (CRM32Pro.mouse_x);
}

int getMousey(void)
{
	return (CRM32Pro.mouse_y);
}

int getMousedx(void)
{
	return mouse_dx;
}

int getMousedy(void)
{
	return mouse_dy;
}


void updateInput(SDL_Event* Event)
{
	mouse_dx = getMousex();
	mouse_dy = getMousey();

	if(Event)
		switch(Event->type)
		{			
			case SDL_KEYDOWN:
				key = Event->key.keysym.sym;
				iskeypressed = true;
				break;

			case SDL_KEYUP:	
				key = SDLK_UNKNOWN;
				iskeypressed = false;
				break;

			case SDL_MOUSEBUTTONDOWN:
				button = Event->button.button;
				isbuttonpressed = true;				
				break;

			case SDL_MOUSEBUTTONUP:
				button = 0;
				isbuttonpressed = false;
				break;
		}

	mouse_dx = getMousex() - mouse_dx;
	mouse_dy = getMousey() - mouse_dy;
}