/*
	Module:		Input Manager
	Programmer:	Michael Scott Stuart
	Version:	1.2.7
	Modified:	10/22/07
	Created:	10/08/07
	Library:	CRM32Pro 4.9.9.0

	1.2.7:
		[10/18/07][MSS][ALL]:	Added Mouse position Delta's.

	1.1.7:

		[10/08/07][MSS][ALL]:	Removed isXXXdown, isXXXup and isXXXheld functions. That
								method proved to be unreliable. 
								Added getKey and getButton. 
								One returns what key was last pressed as long as it's 
								pressed. The other returns what button was last pressed as
								long as it is pressed.
								Added getMousex and getMouseY.
								Both return position information for the Mouse.
		[10/08/07][MSS][ALL]:	Removed all set functions in replace of better code in
								updateInput. Button/Key presses, holds and releases are now
								accurately reported.
		[10/08/07][MSS][ALL]:	Added overloaded isMouseover that takes an SDL_Rect. 
								Cleaned up poor code that was throughout the Module.
								isMouseover is now more versatile, while the cleaned up 
								code makes the module easier to read and understand.
		[10/08/07][MSS][ALL]:	Implemented Verisoning, Function Naming and Changes Designs
								This Module lacked the Design requirements described in the
								Design Documents.

*/

#ifndef _INPUTH_
#define _INPUTH_

#include "..\CRM32Pro.h"

bool isKeyppressed(void);
bool isButtonpressed(void);
bool isKeypressed(SDLKey Key);
bool isButtonpressed(int Button);

SDLKey getKey(void);
Uint8 getButton(void);

int getMousex(void);
int getMousey(void);
int getMousedx(void);
int getMousedy(void);

bool isMouseover(int x, int y, int w, int h);
bool isMouseover(SDL_Rect Area);

void updateInput(SDL_Event* Event);

#endif // _INPUTH_