/*
	Module:		CRM32Pro SDK Standard Include Header (Win32)
	Programmer:	Michael Scott Stuart
	Version:	1.0.7
	Modified:	10/20/07
	Created:	10/20/07 
	Library:	CRM32Pro 4.9.7.0

	1.0.7:

		[10/08/07][MSS][ALL]:	Created. This is basically the same header as from the
								map editor project with a few minor changes.
*/

#pragma once

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows XP or later.
#define WINVER 0x0501		// Change this to the appropriate value to target other versions of Windows.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 6.0 or later.
#define _WIN32_IE 0x0600	// Change this to the appropriate value to target other versions of IE.
#endif

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

// Windows Header Files:
#include <windows.h>

// C RunTime Header Files
#include <stdlib.h>
#include <memory.h>
#include <tchar.h>
#include <string>

// Code Convienience for objects in the std namespace
using namespace std;	

// Link against CRM32Pro STATIC library for releases builds and the dynamic library for
// debug builds.
#ifndef CRM32Pro_LIB
 #define CRM32Pro_LIB
 #ifdef _DEBUG
  #pragma comment(lib, "lib/CRM32Pro.static.lib")
 #else
  #pragma comment(lib, "lib/CRM32Pro.lib")
 #endif
#endif // CRM32Pro_LIB

// CRM32Pro SDK Header Include
#include "CRM32Pro.h"
