#ifndef _MAPMANH_
#define _MAPMANH_

//
// INTERFACE HEADERS
//
// CRM32Pro header include
#include "Crm32Pro.h"

//
// INTERFACE DEFINITIONS
//

//
// INTERFACE FUNCTION PROTOTYPES
//

/*
	MAP2 format
*/

// Initializes the map manager.
bool init_map_manager(void);

// Closes the map manager. Frees memory used by the Map.
void close_map_manager(void);

// Loads the Map from file.
bool load_map(char* mapfilename);

// Saves the Map to file.
bool save_map(char* mapfilename);

// Frees the previous map and creates a new, empty map.
bool new_map(int mapxsize, int mapysize, int layers);

// Removes a Map.
bool free_map(void);

// Resizes a Map.
bool resize_map(int newxsize, int newysize, int newlayers);

// Sets the Map's offsets.
void set_map_offsets(float fx_off, float fy_off);

// Returns the Map's offsets.
void get_map_offsets(float& fx_off, float& fy_off);

// Returns the Map's X and Y size.
void get_map_size(int& xsize, int& ysize);

// Returns the Map's number of layers.
int get_map_layers(void);

// Sets the Map Tile at Map2 Position X, Y.  Returns False if Failed.
bool set_map_xy(int x, int y, int tile, int layer);

// Returns the Map Tile at Map Position X, Y. Returns False if Failed. 
bool get_map_xy(int& tile, int x, int y, int layer);

// Renders the Map to CRM32Pro.screen using pTileset for the tile graphics.  
// WhichLayer = 0 = Draw all layers.
void render_map(CRM32Pro_CTile* pTileset, int WhichLayer);

#endif // _MAPMANH_

// Module: MAP MANAGER