#include ".\ts_win.h"



bool istswinactive;

CRM32Pro_CTile* tsTileset = NULL;
string tsDPFPath = "TILESETS.DPF";
string tsTSPath = "mchip0";
string tsWinStatus = "Okay..";

bool isTSWinActive(void)
{
	return istswinactive;
}

void setTSWinActive(void)
{
	istswinactive = !istswinactive;
}

void setTSWinDPFPath(string DPFPath)
{
	tsDPFPath = DPFPath;
}

void setTSWinTSPath(string TSPath)
{
	tsTSPath = TSPath;
}

const string getTSWinDPFPath(void)
{
	return tsDPFPath;
}

const string getTSWinTSPath(void)
{
	return tsTSPath;
}

void loadTSWinTileset(void)
{
	if(tsTileset)
		delete tsTileset;

	tsTileset = new CRM32Pro_CTile();

	if(!tsTileset->Load((char*)tsDPFPath.c_str(), (char*)tsTSPath.c_str()))
	{
		delete tsTileset;
		tsTileset = NULL;
		tsWinStatus = "Failed Loading Tileset " + tsTSPath + " from DPF " + tsDPFPath;
	}
}

void freeTSWinTileset(void)
{
	if(tsTileset)
	{		
		string name = tsTileset->GetName();
		tsWinStatus = "Freed Tileset " + name;
		delete tsTileset;
		tsTileset = NULL;
	}
	else
	{
		tsWinStatus = "Tileset already freed.";
	}
}

CRM32Pro_CTile* getTSWinTileset(void)
{
	return tsTileset;
}

const string getTSWinStatus(void)
{
	return tsWinStatus;
}

void performTSWinLogic(void)
{
	//determine if a tileset name was clicked on, if so, choose it and close window.		
	//if(isButtonpressed(SDL_BUTTON_LEFT))
//	{
		// Build a virtual list of rectangles, one for each tileset name.
		// Then check if the mouse was over one of those rectangles, if so load that tileset.
		for(int i = 0; i < get_sts_total(); ++i)
		{
			SDL_Rect rect;
			rect.x = TSPICK_XPOS;
			rect.y = TSPICK_YPOS + TSPICK_ITEM_HEIGHT * (i % TSPICK_ITEMS);
			rect.w = TSPICK_ITEM_WIDTH;
			rect.h = TSPICK_ITEM_HEIGHT;
			if(isMouseover(rect) && isButtonpressed(SDL_BUTTON_LEFT))
			{
				// Flip the Tileset Window Active switch.
				setTSWinActive();
				tsTSPath = get_sts_name(i);				
				loadTSWinTileset();
				return;
			}
		}
//	}

}

void renderTSWin(void)
{
		for(int i = 0; i < get_sts_total(); ++i)
		{
			string tileset_name = get_sts_name(i);
			SDL_Rect rect;
			rect.x = TSPICK_XPOS;
			rect.y = TSPICK_YPOS + Tspick_Item->h * (i % TSPICK_ITEMS);
			rect.w = Tspick_Item->w;
			rect.h = Tspick_Item->h;
			if(CRM32Pro.mouse_x >= rect.x && 
				CRM32Pro.mouse_x < (rect.x + rect.w) &&
				CRM32Pro.mouse_y >= rect.y && 
				CRM32Pro.mouse_y < (rect.y + rect.h))
			{
				CRM32Pro.Blit(Tspick_Item_High, NULL, CRM32Pro.screen, &rect);
				Font_White_High->PutString(CRM32Pro.screen, 
				rect.x + 20, rect.y + 4, (char*)tileset_name.c_str(), &rect);
			}
			else
			{
				CRM32Pro.Blit(Tspick_Item, NULL, CRM32Pro.screen, &rect);
				Font_White->PutString(CRM32Pro.screen, 
				rect.x + 20, rect.y + 4, (char*)tileset_name.c_str(), &rect);
			}
		}
}
